
/*
** Copyright (c) 2006 Herbert Poetzl
**
** V0.01	test for new ioctl
** V0.02	O_EXCL and sleep
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>



#define BLKHOLDER _IO(0x12,115)


#define OPEN_FLAGS (O_RDONLY|O_NONBLOCK)
 
static	char	err_flag = 0;

static	char *	cmd_name = NULL;

static	char	opt_oexcl = 0;
static	char	opt_sleep = 0;

static	int 	num_secs = 0;

#define OPTIONS "+hes:"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;

        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-e        try to open exclusive\n"
                    "-s <num>  sleep for <num> seconds\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
	    case 'e':
                opt_oexcl = 1;
                break;
	    case 's':
                num_secs = atol(optarg);
                opt_sleep = 1;
                break;

            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "] ...\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

        for (; optind < argc; optind++) {
	    const char *name = argv[optind];
	    int fd;

	    fd = open(name, OPEN_FLAGS|(opt_oexcl?O_EXCL:0));
	    if (fd<0)
	        perror("open:");

	    if (opt_sleep)
	    	sleep(num_secs);

	    r = ioctl(fd, BLKHOLDER);
	        perror("ioctl:");
	    close (fd);
	}

	exit((err_flag)?1:0);
}

